<?php

namespace RhdEvents;

require_once __DIR__ . '/../vendor/autoload.php';
require_once __DIR__ . '/../config/db.php';

use Medoo\Medoo;

class DbException extends \Exception {}

class Db extends Medoo {

    public function __construct() {
        parent::__construct([
            'database_type'     =>  'mysql',
            'database_name'     =>  \RhdEvents\Config\DBConfig::DB_NAME,
            'server'            =>  \RhdEvents\Config\DBConfig::DB_HOST,
            'username'          =>  \RhdEvents\Config\DBConfig::DB_USER,
            'password'          =>  \RhdEvents\Config\DBConfig::DB_PASS,
        ]);
    }

    public function wasActionSuccessful($result) {
        if ($result->rowCount() < 1) {
            // error
            $errors = $this->error();
            if ($errors[0] != '00000') {
                throw new DbException("[{$errors[0]}] {$errors[2]}");
            }
        }
        return true;
    }
} 
