<?php

namespace RhdEvents;

class Portal {

    public static $db;

    public static function generatePassword($length = 8, $chars = []) {
        if (empty($chars)) {
            $chars = array_merge(range('A', 'Z'), range('a', 'z'), range(0, 9));
        }

        $toReturn = '';
        for($i = 0; $i < $length; $i++) {
            $idx = array_rand($chars, 1);
            $toReturn .= $chars[$idx];
        }
        return $toReturn;
    } // generatePassword

    public static function addFlashMessage($message, $type) {
        if (!isset($_SESSION['flash'])) {
            $_SESSION['flash'] = [];
        }
        if (!isset($_SESSION['flash'][$type])) {
            $_SESSION['flash'][$type] = [];
        }

        $_SESSION['flash'][$type][] = $message;
    } // addFlashMessage

    public static function createFlashMessage() {
        $toReturn = '';
        if (isset($_SESSION['flash']) and (!empty($_SESSION['flash']))) {
            foreach($_SESSION['flash'] as $flashType => $messages) {
                foreach($messages as $messageStr) {
                    $toReturn .= self::createIndividualFlashMessageHTML($messageStr, $flashType);
                }
                unset($_SESSION['flash'][$flashType]);
            }
        }
        return $toReturn;
    } // createFlashMessages

    protected static function createIndividualFlashMessageHTML($html, $type) {
        ob_start();
        ?>
        <div class="row flash-message-row">
            <div class="col-xs-12 ">
                <div class="alert alert-<?= $type ?> text-center flash-message" role="alert">
                    <p class='text-<?= $type ?>'>
                        <?= $html ?>
                    </p>
                </div>
            </div>
        </div> <!-- .row -->
        <?php
        $toReturn = ob_get_clean();
        return $toReturn;
    }

    public static function refresh() {
        header("Location: {$_SERVER['REQUEST_URI']}");
        exit();
    }
}
