<?php

require_once __DIR__ . '/../vendor/autoload.php';
require_once __DIR__ . '/../lib/class.db.php';

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\IOFactory;

$db = new \RhdEvents\Db();

$ALPHARANGE = range('A', 'Z');

$currentDT = new \DateTime($_REQUEST['start_date']);
$endDateDT = new \DateTime($_REQUEST['end_date']);

$spreadsheet = new Spreadsheet();

$spreadsheetIndex = 0;
$spreadsheet->removeSheetByIndex($spreadsheetIndex);
$spreadsheet->getDefaultStyle()->getFont()->setName('Times New Roman');

$spreadsheet->getDefaultStyle()
    ->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);



while($currentDT <= $endDateDT) {
    $myWorkSheet = new \PhpOffice\PhpSpreadsheet\Worksheet\Worksheet($spreadsheet, $currentDT->format('m-d-Y'));
    $spreadsheet->addSheet($myWorkSheet, $spreadsheetIndex);

    $whereClause = [
        'work_logs.active'  =>  true
    ];

    /*
    if (isset($_REQUEST['worker_id'])) {
        $whereClause['work_logs.worker_id'] = $_REQUEST['worker_id'];
        $whereClause['workers.active'] = true;
    }
    */

    $startDate = $currentDT->format('Y-m-d');
    $currentDT->modify('+7 days');
    $endDate = $currentDT->format('Y-m-d');

    /*
    if (isset($_REQUEST['start_date'])) {
        //$whereClause['start_datetime[>]'] = $_REQUEST['start_date'];
        $whereClause['start_datetime[>]'] = $currentDT->format('Y-m-d');
    }
    if (isset($_REQUEST['end_date'])) {
        //$whereClause['end_datetime[<]'] = $_REQUEST['end_date'];
        $currentDT->modify('+7 days');
        $whereClause['end_datetime[<]'] = $currentDT->format('Y-m-d');
    }
    */

    $sql = "SELECT worker_id FROM `work_logs` WHERE start_datetime >= '{$startDate}' AND end_datetime < '{$endDate}' AND active = 1 GROUP BY worker_id";
    $stmt = $db->pdo->prepare($sql);
    $stmt->execute();
    $activeWorkersDuringRangeRows = $stmt->fetchAll();



    $activeSheet = $spreadsheet->setActiveSheetIndex($spreadsheetIndex++);
    $activeSheet->getStyle('A1:R2')->getFill()
        ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
        ->getStartColor()->setARGB('FFFF0000');
    $activeSheet->mergeCells('A1:R1');
    $activeSheet->setCellValue('A3', 'Name');
    $activeSheet->getStyle('A3:R3')->getFill()
        ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
        ->getStartColor()->setARGB('FFFFFF00');

    $sheetStartDate = new \DateTime($startDate);
    $cellIndex = 0;
    for($i = 0; $i < 7; $i++) {
        $cellIndex++;
        $activeSheet->setCellValue($ALPHARANGE[$cellIndex] . '3', $sheetStartDate->format('m/d/Y'));
        $mergeCellsStr = "{$ALPHARANGE[$cellIndex]}3:";
        $cellIndex++;
        $mergeCellsStr .= "{$ALPHARANGE[$cellIndex]}3";

        $activeSheet->mergeCells($mergeCellsStr);
        //$activeSheet->setCellValue($ALPHARANGE[$cellIndex] . '3', $sheetStartDate->format('m/d/Y'));

        $sheetStartDate->modify('+1 day');

    }

    $activeSheet->setCellValue('P3', 'Misc Hrs');
    $activeSheet->mergeCells('P3:Q3');

    $activeSheet->setCellValue('R3', 'Total Hrs');

    $startingRow = 4;



    foreach($activeWorkersDuringRangeRows as $idx => $row) {
        $workerID = $row['worker_id'];
        $workerRow = $db->get('workers', '*', ['worker_id' => $workerID]);

        $activeSheet->setCellValue("A{$startingRow}", $workerRow['first_name'] . ' ' . $workerRow['last_name']);
        //$startingRow++;
        $activeSheet->setCellValue("A" . ($startingRow + 1), 'IN/OUT');
        //$startingRow++;
        $activeSheet->setCellValue("A" . ($startingRow + 2), 'Description of Duties');
        //$startingRow++;

        $startingColumnIndex = 1;

        if ($idx % 2 == 1) {
            // b1b0b0
            $activeSheet->getStyle('A' .  $startingRow . ':R' . ($startingRow + 2))->getFill()
                ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                ->getStartColor()->setARGB('F0B1B0B0');
        }

        $activeSheet->getStyle('A' .  $startingRow . ':R' . ($startingRow + 2))
            ->getBorders()->getAllBorders()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);

        $sheetStartDate = new \DateTime($startDate);
        for($i = 0; $i < 7; $i++) {
            $logRow = $db->get('work_logs', '*', [
                'worker_id'             =>  $workerID,
                'start_datetime[>]'     =>  $sheetStartDate->format('Y-m-d') . ' 00:00:00',
                'end_datetime[<]'       =>  $sheetStartDate->format('Y-m-d') . ' 23:59:59',
            ]);
            //var_dump($db->last()); die();
            
            if (!empty($logRow)) {
                $startTimestamp = new \DateTime($logRow['start_datetime']);
                $endTimestamp = new \DateTime($logRow['end_datetime']);

                $diff = $endTimestamp->getTimestamp() - $startTimestamp->getTimestamp();
                $diff /= (60 * 60);

                $activeSheet->setCellValue($ALPHARANGE[$startingColumnIndex] . $startingRow, number_format($diff, 1));
                $activeSheet->mergeCells($ALPHARANGE[$startingColumnIndex] . $startingRow . ':' . $ALPHARANGE[$startingColumnIndex + 1] . $startingRow);

                $activeSheet->setCellValue($ALPHARANGE[$startingColumnIndex] . ($startingRow + 1), $startTimestamp->format('h:i a'));
                $activeSheet->setCellValue($ALPHARANGE[$startingColumnIndex + 1] . ($startingRow + 1), $endTimestamp->format('h:i a'));

                $activeSheet->setCellValue($ALPHARANGE[$startingColumnIndex] . ($startingRow + 2), $logRow['description']);
                $activeSheet->mergeCells($ALPHARANGE[$startingColumnIndex] . ($startingRow + 2) . ':' . $ALPHARANGE[$startingColumnIndex + 1] . ($startingRow + 2));

            }

            $startingColumnIndex += 2;
            $sheetStartDate->modify('+1 day');
        }

        $activeSheet->setCellValue('R' . $startingRow ,"=SUM(B{$startingRow}:Q{$startingRow})");
        $startingRow += 3;
        
    }

    foreach($ALPHARANGE as $idx => $column) {
        $width = 12;
        $activeSheet->getColumnDimension($column)->setWidth(12);
        if ($column == 'A') {
            $activeSheet->getColumnDimension($column)->setAutoSize(true);
        }
        if ($column == 'R') {
            break;
        }
    }

    //$activeSheet->getStyle("A1:R{$startingRow}")->getFont()->setName('Times New Roman');
}
// Redirect output to a client’s web browser (Xlsx)
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="01simple.xlsx"');
header('Cache-Control: max-age=0');
// If you're serving to IE 9, then the following may be needed
header('Cache-Control: max-age=1');
// If you're serving to IE over SSL, then the following may be needed
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
header('Pragma: public'); // HTTP/1.0
$writer = IOFactory::createWriter($spreadsheet, 'Xlsx');
$writer->save('php://output');
exit;