<?php
require_once __DIR__ . '/../lib/class.db.php';
require_once __DIR__ . '/../lib/class.portal.php';
require_once __DIR__ . '/../vendor/autoload.php';

use RhdEvents\Portal as Portal;

session_start();

$db = new \RhdEvents\Db();

$whereClause = [
    'work_logs.active'  =>  true
];
if (isset($_REQUEST['worker_id'])) {
    $whereClause['work_logs.worker_id'] = $_REQUEST['worker_id'];
    $whereClause['workers.active'] = true;
}

if (isset($_REQUEST['start_date'])) {
    $whereClause['start_datetime[>]'] = $_REQUEST['start_date'];
}
if (isset($_REQUEST['end_date'])) {
    $whereClause['end_datetime[<]'] = $_REQUEST['end_date'];
}


$rows = $db->select('work_logs', [
    "[<]workers"    =>  ['worker_id' => 'worker_id']
], '*', $whereClause);

require_once __DIR__ . '/../lib/inc.header.php';
?>
<link href="//cdnjs.cloudflare.com/ajax/libs/jquery.tablesorter/2.31.1/css/theme.bootstrap_3.min.css" rel="stylesheet" />

    <div class='row'>
        <div class='col-xs-12 table-responsive'>
            <table class='table' id='time-entries-table'>
                <thead>
                    <tr>
                        <th>First Name</th>
                        <th>Last Name</th>
                        <th>Date</th>
                        <th>Start Time</th>
                        <th>End Time</th>
                        <th>Description</th>
                    </tr>
                </thead>
                <tbody>
<?php
if (empty($rows)) {
    ?>
                    <tr>
                        <td colspan='100' class='text-center'>No Rows Found</td>
                    </tr>
    <?php
}
else {
    foreach($rows as $row) {
        $startDT = new \DateTime($row['start_datetime']);
        $endDT = new \DateTime($row['end_datetime']);

        ?>
                    <tr>
                        <td><?= $row['first_name'] ?></td>
                        <td><?= $row['last_name'] ?></td>
                        <td><?= $endDT->format('m/d/Y') ?></td>
                        <td><?= $startDT->format('h:i a') ?></td>
                        <td><?= $endDT->format('h:i a') ?></td>
                        <td><?= $row['description'] ?></td>
                    </tr>
        <?php
    }
}
?>
                </tbody>
            </table>
        </div>
    </div>
</div>
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<script src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.5/js/bootstrap.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery.tablesorter/2.31.1/js/jquery.tablesorter.combined.min.js"></script>
<script>
$(document).ready(function(){
    $.tablesorter.themes.bootstrap = {
    // these classes are added to the table. To see other table classes available,
    // look here: http://getbootstrap.com/css/#tables
    table        : 'table table-bordered table-striped',
    caption      : 'caption',
    // header class names
    header       : 'bootstrap-header', // give the header a gradient background (theme.bootstrap_2.css)
    sortNone     : '',
    sortAsc      : '',
    sortDesc     : '',
    active       : '', // applied when column is sorted
    hover        : '', // custom css required - a defined bootstrap style may not override other classes
    // icon class names
    icons        : '', // add "bootstrap-icon-white" to make them white; this icon class is added to the <i> in the header
    iconSortNone : 'bootstrap-icon-unsorted', // class name added to icon when column is not sorted
    iconSortAsc  : 'glyphicon glyphicon-chevron-up', // class name added to icon when column has ascending sort
    iconSortDesc : 'glyphicon glyphicon-chevron-down', // class name added to icon when column has descending sort
    filterRow    : '', // filter row class; use widgetOptions.filter_cssFilter for the input/select element
    footerRow    : '',
    footerCells  : '',
    even         : '', // even row zebra striping
    odd          : ''  // odd row zebra striping
  };
    <?php
    if (!empty($rows)) {
        ?>
        $('#time-entries-table').tablesorter({
            theme:  'bootstrap',
            headerTemplate : '{content} {icon}', // new in v2.7. Needed to add the bootstrap icon!
        });
    <?php
    }
    ?>
});
</script>
</body>
</html>

